//-------------------------------------------------------------------=72
//
// Copyright (C) Columbia University, 1998-1999. All Rights Reserved.
//
//-------------------------------------------------------------------=72
//
// RVView.h : interface of the RVView class
//
//-------------------------------------------------------------------=72
//
// Author:				 Tomoo Mitsunaga
//
// Version:              1.0
//
// Modification History:
//  Dec/05/1998:	Created	
//
// Bugs:
//
//-------------------------------------------------------------------=72

#if !defined(AFX_RVVIEW_H__EA36734D_65F9_11D2_A55B_00C04F78848E__INCLUDED_)
#define AFX_RVVIEW_H__EA36734D_65F9_11D2_A55B_00C04F78848E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "RVViewUserDefinePart.h"
#include "RVRootHandler.h"

class RVView : public CView
{
protected: // create from serialization only
	RVView();
	DECLARE_DYNCREATE(RVView)

// Attributes
public:
	RVDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(RVView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~RVView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(RVView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

  public:

	RVViewUserDefinePart mUDP;
	RVRootHandler mREH;

	void RVView::OnViewEqWhole();
};

#ifndef _DEBUG  // debug version in RVView.cpp
inline RVDoc* RVView::GetDocument()
   { return (RVDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RVVIEW_H__EA36734D_65F9_11D2_A55B_00C04F78848E__INCLUDED_)

//-------------------------------------------------------------------=72
// End of RVView.h
//-------------------------------------------------------------------=72
